

#property copyright ""
#property link      ""


//----------------------- INCLUDES
#include <stdlib.mqh>


//----------------------- Variables de MaCross
extern string  
         Nombre_del_EA       = "---------- MaCross Macd No Magic EA v1";
extern double  
         Lots              = 0.2,
         StopLoss          = 350,
         TakeProfit        = 0,
         TrailingStop      = 0;

extern string  
         Parametros_de_MaCross = "";
extern int
         FastMAPeriod        = 1,
         FastMAType          = 0,    //0:SMA 1:EMA 2:SMMA 3:LWMA
         FastMAPrice         = 1,    //0:Close 1:Open 2:High 3:Low 4:Median 5:Typical 6:Weighted
         SlowMAPeriod        = 200,
         SlowMAType          = 3,    //0:SMA 1:EMA 2:SMMA 3:LWMA
         SlowMAPrice         = 0;    //0:Close 1:Open 2:High 3:Low 4:Median 5:Typical 6:Weighted

//------------------------ Variables del MACD
extern string  
         Parametros_de_Macd = "";
extern double MACDOpenLevel  = 0.0001;
extern double MACDCloseLevel = -0.0001;

//-------------------------------------------------------+
extern string  
         Parametros_de_salida      = "";
extern bool
         ReverseCondition  = false, // TRUE:buy-sell , sell-buy
         ConfirmedOnEntry  = true,  // TRUE:entry on the next signal bar
         StopAndReverse    = true,  // TURE:if signal change, exit and reverse order
         PureSAR           = false;  // TRUE:no SL, no TP, no TS
         
extern string  
         Parametros_de_la_Orden     = "";
extern int
         NumberOfTries     = 10,
         Slippage          = 30;
         

extern string  
         Parametros_de_Tiempo   = "---------- Tiempo de actividad del EA";
extern bool    
         UseHourTrade      = false;         
extern int     
         StartHour         = 10,
         EndHour           = 11;

extern string  
         Parametros_de_testeo= "";
extern bool
         PrintControl      = true,
         Show_Settings     = true;


//----------------------- GLOBAL VARIABLE
static int 
         TimeFrame         = 5;
string
         TicketComment     = "MaCross Macd No Magic EA v1",
         LastTrade;


//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
{

//----------------------- GENERATE MAGIC NUMBER AND TICKET COMMENT
//----------------------- SOURCE : PENGIE
   
	TicketComment  = StringConcatenate(TicketComment, "-", Symbol(), "-", Period());
   if(Show_Settings) subPrintDetails();
   else Comment("");
   
//----------------------- INITIALIZE PURE Stop And Reverse
//----------------------- NO STOP LOSS, NO TAKE PROFIT, NO TRAILING STOP
   if(PureSAR)
   {
      StopLoss       = 0;
      TakeProfit     = 0;
      TrailingStop   = 0;
   }

   return(0);
}

//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
{
 
//----------------------- PREVENT RE-COUNTING WHILE USER CHANGING TIME FRAME
//----------------------- SOURCE : CODERSGURU
   TimeFrame=Period(); 
   return(0);
}


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int start()
{

   double 
         MacdCurrent,
         MacdPrevious,
         FastMAPrevious,
         FastMACurrent,
         SlowMAPrevious,
         SlowMACurrent;
                   
   int   
         cnt,
         ticket,
         total;
         
   bool
         BuyCondition,
         SellCondition;
                 
         
//----------------------- TIME FILTER
   if (UseHourTrade)
   {
      if(!(Hour()>=StartHour && Hour()<=EndHour))
      {
         Comment("Non-Trading Hours!");
         return(0);
      }
   }

//----------------------- CHECK CHART NEED MORE THAN 100 BARS
   if(Bars<100)
   {
      Print("bars less than 100");
      return(0);  
   }



//----------------------- SET VALUE FOR VARIABLE
//----------------------- MACD
   if(ConfirmedOnEntry)
   {
      FastMAPrevious = iMA(NULL,TimeFrame,FastMAPeriod,0,FastMAType,FastMAPrice,2);
      FastMACurrent  = iMA(NULL,TimeFrame,FastMAPeriod,0,FastMAType,FastMAPrice,1);
      SlowMAPrevious = iMA(NULL,TimeFrame,SlowMAPeriod,0,SlowMAType,SlowMAPrice,2);
      SlowMACurrent  = iMA(NULL,TimeFrame,SlowMAPeriod,0,SlowMAType,SlowMAPrice,1);
      MacdCurrent    = iMACD(NULL,0,13,21,1,PRICE_CLOSE,MODE_MAIN,0);
      MacdPrevious   = iMACD(NULL,0,13,21,1,PRICE_CLOSE,MODE_MAIN,1);
   }
   else
   {
      FastMAPrevious = iMA(NULL,TimeFrame,FastMAPeriod,0,FastMAType,FastMAPrice,1);
      FastMACurrent  = iMA(NULL,TimeFrame,FastMAPeriod,0,FastMAType,FastMAPrice,0);
      SlowMAPrevious = iMA(NULL,TimeFrame,SlowMAPeriod,0,SlowMAType,SlowMAPrice,1);
      SlowMACurrent  = iMA(NULL,TimeFrame,SlowMAPeriod,0,SlowMAType,SlowMAPrice,0);
      MacdCurrent    = iMACD(NULL,0,13,21,1,PRICE_CLOSE,MODE_MAIN,0);
      MacdPrevious   = iMACD(NULL,0,13,21,1,PRICE_CLOSE,MODE_MAIN,1);
   }
   

//----------------------- CONDITION CHECK
   if(!ReverseCondition)
   {
//----------------------- BUY CONDITION   
      BuyCondition   = (FastMAPrevious<SlowMAPrevious &&
                        FastMACurrent>SlowMACurrent && 
                        MacdCurrent>MacdPrevious &&
                        MacdCurrent>MACDOpenLevel);      

//----------------------- SELL CONDITION   
      SellCondition  = (FastMAPrevious>SlowMAPrevious &&
                        FastMACurrent<SlowMACurrent &&
                        MacdCurrent<MacdPrevious &&
                        MacdCurrent<MACDCloseLevel);
   }
   else
   {
//----------------------- BUY CONDITION   
      SellCondition  = (FastMAPrevious<SlowMAPrevious &&
                        FastMACurrent>SlowMACurrent &&
                        MacdCurrent>MacdPrevious &&
                        MacdCurrent>MACDOpenLevel);

//----------------------- SELL CONDITION   
      BuyCondition   = (FastMAPrevious>SlowMAPrevious &&
                        FastMACurrent<SlowMACurrent &&
                        MacdCurrent<MacdPrevious &&
                        MacdCurrent<MACDCloseLevel);
   }                        



//----------------------- not available



//----------------------- STOP AND REVERSE
if(StopAndReverse && subTotalTrade()>0)
   {
      if((LastTrade=="BUY" && SellCondition) || (LastTrade=="SELL" && BuyCondition))
      {
         subCloseOrder();
         if(IsTesting() && PrintControl) Print("STOP AND REVERSE !");
      }
   }


//----------------------- ENTRY
//----------------------- TOTAL ORDER BASE ON MAGICNUMBER AND SYMBOL
   total = subTotalTrade();

//----------------------- IF NO TRADE
   if(total<1) 
   {
//----------------------- BUY CONDITION   
      if(BuyCondition)
      {
         ticket      = subOpenOrder(OP_BUY); // open BUY order
         subCheckError(ticket,"BUY");
         LastTrade   = "BUY";
         return(0);
      }

//----------------------- SELL CONDITION   
      if(SellCondition)
      {
         ticket      = subOpenOrder(OP_SELL); // open SELL order
         subCheckError(ticket,"SELL");
         LastTrade   = "SELL";
         return(0);
      }
      return(0);
   }
   
//----------------------- TRAILING STOP SECTION
   if(TrailingStop>0)
   {
      total = OrdersTotal();
      for(cnt=0;cnt<total;cnt++)
      {
         OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);

         if(OrderType()<=OP_SELL &&
            OrderSymbol()==Symbol())
         {
            subTrailingStop(OrderType());
            return(0);
         }
      }
   }            
   return(0);
}

//----------------------- END PROGRAM

//+------------------------------------------------------------------+
//| DEFINICION DE FUNCIONES
//+------------------------------------------------------------------+



//----------------------- NUMBER OF ORDER BASE ON SYMBOL AND MAGICNUMBER FUNCTION
int subTotalTrade()
{
   int
      cnt, 
      total = 0;

   for(cnt=0;cnt<OrdersTotal();cnt++)
   {
      OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES);
      if(OrderType()<=OP_SELL &&
         OrderSymbol()==Symbol()) total++;
      if(OrderType()<=OP_BUY &&
         OrderSymbol()==Symbol()) total++;
   }
   return(total);
}


//----------------------- OPEN ORDER FUNCTION
//----------------------- SOURCE   : CODERSGURU
//----------------------- SOURCE   : PENGIE
//----------------------- MODIFIED : FIREDAVE
int subOpenOrder(int type)
{
   int
         ticket      = 0,
         err         = 0,
         c           = 0;
         
   double         
         aStopLoss   = 0,
         aTakeProfit = 0,
         bStopLoss   = 0,
         bTakeProfit = 0;

   if(StopLoss!=0)
   {
      aStopLoss   = Ask-StopLoss*Point;
      bStopLoss   = Bid+StopLoss*Point;
   }
   
   if(TakeProfit!=0)
   {
      aTakeProfit = Ask+TakeProfit*Point;
      bTakeProfit = Bid-TakeProfit*Point;
   }
   
   if(type==OP_BUY)
   {
      for(c=0;c<NumberOfTries;c++)
         {
         ticket=OrderSend(Symbol(),OP_BUY,Lots,Ask,Slippage,aStopLoss,aTakeProfit,TicketComment,0,Green);
         err=GetLastError();
         if(err==0)
            { 
            break;
            }
         else
            {
            if(err==4 || err==137 ||err==146 || err==136) //Busy errors
               {
               Sleep(5000);
               continue;
               }
            else //normal error
               {
               break;
               }  
         }
      }   
   }
   if(type==OP_SELL)
   {   
      for(c=0;c<NumberOfTries;c++)
      {
         ticket=OrderSend(Symbol(),OP_SELL,Lots,Bid,Slippage,bStopLoss,bTakeProfit,TicketComment,0,Red);
         err=GetLastError();
         if(err==0)
         { 
            break;
         }
         else
         {
            if(err==4 || err==137 ||err==146 || err==136) //Busy errors
            {
               Sleep(5000);
               continue;
            }
            else //normal error
            {
               break;
            }  
         }
      }   
   }  
   return(ticket);
}


//----------------------- CLOSE ORDER FUNCTION
void subCloseOrder()
{
   int
      cnt, 
      total = 0;

   total = OrdersTotal();
   for(cnt=total-1;cnt>=0;cnt--)
   {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);

      if(OrderSymbol()==Symbol())
      {
         switch(OrderType())
         {
            case OP_BUY      :
               OrderClose(OrderTicket(),OrderLots(),Bid,Slippage,Violet);
               break;
               
            case OP_SELL     :
               OrderClose(OrderTicket(),OrderLots(),Ask,Slippage,Violet);
               break;
               
            case OP_BUYLIMIT :
            case OP_BUYSTOP  :
            case OP_SELLLIMIT:
            case OP_SELLSTOP :
               OrderDelete(OrderTicket());
         }
      }
   }      
}


//----------------------- TRAILING STOP FUNCTION
//----------------------- SOURCE   : CODERSGURU
//----------------------- MODIFIED : FIREDAVE
void subTrailingStop(int Type)
{
   if(Type==OP_BUY)   // buy position is opened   
   {
      if(Bid-OrderOpenPrice()>Point*TrailingStop &&
         OrderStopLoss()<Bid-Point*TrailingStop)
      {
         OrderModify(OrderTicket(),OrderOpenPrice(),Bid-Point*TrailingStop,OrderTakeProfit(),0,Green);
         return(0);
      }
   }

   if(Type==OP_SELL)   // sell position is opened   
   {
      if(OrderOpenPrice()-Ask>Point*TrailingStop)
      {
      if(OrderStopLoss()>Ask+Point*TrailingStop || OrderStopLoss()==0)
      {
         OrderModify(OrderTicket(),OrderOpenPrice(),Ask+Point*TrailingStop,OrderTakeProfit(),0,Red);
         return(0);
      }
      }
   }
}



//----------------------- CHECK ERROR CODE FUNCTION
//----------------------- SOURCE : CODERSGURU
void subCheckError(int ticket, string Type)
{
    if(ticket>0) 
    {
      if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) Print(Type + " order opened : ",OrderOpenPrice());
    }
    else Print("Error opening " + Type + " order : ", ErrorDescription(GetLastError()));
}

//----------------------- GENERATE MAGIC NUMBER BASE ON SYMBOL AND TIME FRAME FUNCTION
//----------------------- SOURCE   : PENGIE
//----------------------- MODIFIED : FIREDAVE



//----------------------- PRINT COMMENT FUNCTION
//----------------------- SOURCE : CODERSGURU
void subPrintDetails()
{
   string sComment   = "";
   string sp         = "---------------------------------------------------------------\n";
   string NL         = "\n";

   sComment = sp;
   
   sComment = sComment + "Lote= " + DoubleToStr(Lots,1) + "  | " + "TakeProfit=  " + DoubleToStr(TakeProfit,0) + "  | "+ "StopLoss= " + DoubleToStr(StopLoss,0) + NL;
   sComment = sComment + sp;
   sComment = sComment + "Riesgo = $"+DoubleToStr(StopLoss*Lots,2)+ " = "+DoubleToStr((StopLoss*Lots*100)/AccountBalance(),2)+"%"+"  del saldo actual"+ NL;
   sComment = sComment + sp;   
   sComment = sComment + sp;
   
   sComment = sComment + "Parmetros del Cruce de Moving Averages"+NL;
   sComment = sComment + sp;
   sComment = sComment + "Ma Rpido  =  " +(FastMAPeriod)+ "   | "+"  Tipo  "+(FastMAType)+ "   | "+"  Precio  "+(FastMAPrice)+ NL;
   sComment = sComment + sp;
   sComment = sComment + "Ma Lento =  " +(SlowMAPeriod)+ "   | "+"  Tipo  "+(SlowMAType)+ "   | "+"  Precio  "+(SlowMAPrice)+ NL;
   sComment = sComment + sp;
   sComment = sComment + "Tipo = 0:SMA / 1:EMA / 2:SMMA / 3:LWMA"+ NL;
   sComment = sComment + sp;
   sComment = sComment + "Precio = 0:Close / 1:Open / 2:High / 3:Low " + NL;
   sComment = sComment + "         4:Median /  5:Typical /  6:Weighted" + NL;      

   
   Comment(sComment);
}




//----------------------- END FUNCTION